<?php

namespace Ems\portalGestor\Service;

use Ems\portalGestor\Util\HcmServices;

class TreinamentoService {
    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        HcmServices $hcmServices
    ) {
        $this->hcmServices = $hcmServices;
    }

    public function getCurso(
        int $nrOrg
    ): array {
        $route = 'getCurso';

        $params = [
            'requestType' => 'Row',
            'row' => [],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $cursos = $result['dataset'][$route];

        return $cursos;
    }

    public function getPerfilAcesso(
        int $nrOrg
    ): array {
        $route = 'getPerfilAcesso';

        $params = [
            'requestType' => 'Row',
            'row' => [],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $perfis = $result['dataset'][$route];

        return $perfis;
    }

    public function getMetodo(
        int $nrOrg
    ): array {
        $route = 'getMetodo';

        $params = [
            'requestType' => 'Row',
            'row' => [],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $metodos = $result['dataset'][$route];

        return $metodos;
    }
}