/******************************************************************************/
/*                                                                            */
/* Trigger: SINCRONIZA_PRODMODPROD                                            */
/* Tabela : PRODMODPROD -> PRODMODFILI                                        */
/*                                                                            */
/* Atualiza os dados da tabela PRODMODPROD na tabela PRODMODFILI              */
/*                                                                            */
/* Criao:                                                                   */
/* 11/08/2009 - Fleas                                                        */
/*                                                                            */
/******************************************************************************/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'SINCRONIZA_PRODMODPROD'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER SINCRONIZA_PRODMODPROD 
GO


CREATE TRIGGER SINCRONIZA_PRODMODPROD 
ON PRODMODPROD
AFTER INSERT
AS
	DECLARE @V_OPERACAO			VARCHAR(1);
	DECLARE @V_NEW_CDMODULOPROD	        VARCHAR(10);
	DECLARE @V_NEW_CDPRODUTO		VARCHAR(10);
	DECLARE @V_OLD_CDMODULOPROD	        VARCHAR(10);
	DECLARE @V_OLD_CDPRODUTO		VARCHAR(10);

BEGIN
   DECLARE C_PRODMODPROD CURSOR FOR
      SELECT
      	 'I' OPERACAO,
      	 CDMODULOPROD	NEW_CDMODULOPROD,
      	 CDPRODUTO		NEW_CDPRODUTO,
      	 NULL			OLD_CDMODULOPROD,
      	 NULL			OLD_CDPRODUTO
         FROM
      	 INSERTED
       WHERE
      	(0 = (SELECT COUNT(*) FROM DELETED))

   OPEN C_PRODMODPROD;
   FETCH NEXT FROM C_PRODMODPROD INTO @V_OPERACAO, @V_NEW_CDMODULOPROD, @V_NEW_CDPRODUTO, @V_OLD_CDMODULOPROD, @V_OLD_CDPRODUTO;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
   	IF @V_OPERACAO = 'I'
   	BEGIN
   		INSERT INTO PRODMODFILI
   			(CDMODULOPROD, CDPRODUTO, CDFILIAL)
   			(SELECT @V_NEW_CDMODULOPROD, @V_NEW_CDPRODUTO, CDFILIAL
   			   FROM MODULOFILI MF
   			  WHERE MF.CDMODULOPROD = @V_NEW_CDMODULOPROD
   			    AND NOT EXISTS (SELECT CDMODULOPROD, CDPRODUTO, CDFILIAL
   							  FROM PRODMODFILI PMF
   							 WHERE PMF.CDMODULOPROD = MF.CDMODULOPROD
   							   AND PMF.CDPRODUTO    = @V_NEW_CDPRODUTO))
   	END;
   	FETCH NEXT FROM C_PRODMODPROD INTO @V_OPERACAO, @V_NEW_CDMODULOPROD, @V_NEW_CDPRODUTO, @V_OLD_CDMODULOPROD, @V_OLD_CDPRODUTO;
   END;
   CLOSE C_PRODMODPROD;
   DEALLOCATE C_PRODMODPROD;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'SINCRONIZA_PRODMODPROD','5.07.015';
GO